%global zartcommit 54bc6ec2b855b8c31fe317a68e4da8a3f786e8c7
%global zartshortcommit %(c=%{zartcommit}; echo ${c:0:7})

%global communitycommit 1ac621610d4a0f7dae377b19c828851d09604fe4
%global communityshortcommit %(c=%{communitycommit}; echo ${c:0:7})


%global gimpplugindir %(gimptool --gimpplugindir)/plug-ins

%define use_system_cimg 0

%define vshort 218

Summary: GREYC's Magic for Image Computing
Name: gmic
Version: 2.1.8
Release: 1%{?dist}
Source0: http://gmic.eu/files/source/%{name}_%{version}.tar.gz
Source1: https://github.com/c-koi/gmic-qt/archive/v.%{vshort}.tar.gz
Source2: https://github.com/c-koi/zart/archive/%{zartcommit}/zart-%{zartshortcommit}.tar.gz
Source3: https://github.com/dtschump/gmic-community/archive/%{communitycommit}/gmic-community-%{communityshortcommit}.tar.gz
Patch1: %{name}-%{version}-qmake.patch
Patch2: nostrip.patch

License: CeCILL
Url: http://gmic.sourceforge.net/index.shtml
Buildroot: %{_tmppath}/%{name}-%{version}-root
Group: Applications/Multimedia
%if %{use_system_cimg}
BuildRequires: CImg-devel
%endif
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: libtiff-devel
BuildRequires: libpng-devel
BuildRequires: libjpeg-devel
BuildRequires: fftw-devel
BuildRequires: OpenEXR-devel
BuildRequires: zlib-devel
BuildRequires: gtk2-devel
BuildRequires: gimp-devel-tools
BuildRequires: hdf5-devel
BuildRequires: opencv-devel
BuildRequires: GraphicsMagick-c++-devel
BuildRequires: ilmbase-devel
BuildRequires: qt5-qtbase-devel
BuildRequires: libcurl-devel

%description
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

%package devel
Requires: %{name}%{?_isa} = %{version}-%{release}
Summary: Development files for G'MIC

%package static
Requires: %{name}%{?_isa} = %{version}-%{release}
Summary: static-linked development files for G'MIC

%package gimp
Requires: %{name}%{?_isa} = %{version}-%{release}
Summary: G'MIC plugin for GIMP

%description devel
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

Provides files for building applications against the G'MIC API

%description static
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

Provides statically linked files for building applications 
against the G'MIC API

%description gimp
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

Provides a plugin for using G'MIC from GIMP

%prep
%setup -q
%patch1 -p1 -b.qmake5
%patch2 -p1 -b.nostrip
mkdir -p gmic-qt zart ../gmic-community
tar -xvf %{SOURCE1} -C gmic-qt --strip-components=1
tar -xvf %{SOURCE2} -C zart --strip-components=1
tar -xvf %{SOURCE3} -C ../gmic-community --strip-components=1

%build
#export CCACHE_DISABLE=1
cd src
%if %{use_system_cimg}
# We want to build against the system installed CImg package.
# G'MIC provides no way todo this, so we just copy the file
# over what's there already
mv CImg.h CImg.h.bak
cp /usr/include/CImg.h CImg.h
%endif

# Setting FFMPEG flags to empty string to disable G'MIC's
# use of that library. It will fallback to exec'ing the
# CLI tools if they happen to be installed.
make FFMPEG_CFLAGS= FFMPEG_LDFLAGS= OPT_CFLAGS="%{optflags} -fsigned-char"

%install
iconv -f iso8859-1 -t utf-8 COPYING > COPYING.conv && mv -f COPYING.conv COPYING

cd src
make DESTDIR=$RPM_BUILD_ROOT install

# Makefile is not multilib aware
if test "%{_prefix}/lib" != "%{_libdir}"
then
    mv $RPM_BUILD_ROOT/%{_prefix}/lib/* $RPM_BUILD_ROOT/%{_libdir}/
fi

# Makefile creates too many intermediate symlinks for the library
rm -f $RPM_BUILD_ROOT/%{_libdir}/libgmic.so.1
rm -f $RPM_BUILD_ROOT/%{_libdir}/libgmic.so.1.5
ln -s libgmic.so.%{version} $RPM_BUILD_ROOT/%{_libdir}/libgmic.so.1

# Sourced files shouldn't be executable
chmod -x $RPM_BUILD_ROOT/%{_sysconfdir}/bash_completion.d/gmic

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README COPYING
%{_bindir}/gmic
%{_bindir}/zart
%{_bindir}/gmic_krita_qt
%{_bindir}/gmic_qt
%{_sysconfdir}/bash_completion.d/gmic
%{_libdir}/libgmic.so.*
%{_mandir}/man1/%{name}.1.gz
%{_mandir}/fr/man1/%{name}.1.gz

%files devel
%defattr(-,root,root)
%{_prefix}/include/gmic.h
%{_libdir}/libgmic.so

%files static
%defattr(-,root,root)
%{_prefix}/include/gmic_libc.h
%{_libdir}/libcgmic.so
%{_libdir}/libcgmic.so.*

%files gimp
%defattr(-,root,root)
%{gimpplugindir}/gmic_gimp_qt
%{gimpplugindir}/gmic_gimp_gtk
%{gimpplugindir}/gmic_film_cluts.gmz

%changelog
* Fri Jan 12 2018 josef radinger <cheese@nosuchhost.net> - 2.1.8-1
- bump version

* Sat Oct 28 2017 josef radinger <cheese@nosuchhost.net> - 2.1.3-1
- bump version
- add gmic-qt
- remove patch1

* Wed Jun 07 2017 josef radinger <cheese@nosuchhost.net> - 2.0.0-1
- bump version

* Sun Mar 05 2017 josef radinger <cheese@nosuchhost.net> - 1.7.9-1
- bump version

* Fri Sep 30 2016 josef radinger <cheese@nosuchhost.net> - 1.7.7-1
- bump version
- remove zart
- static package is obsolete for now

* Wed Aug 17 2016 josef radinger <cheese@nosuchhost.net> - 1.7.5-1
- bump version

* Tue Aug 09 2016 josef radinger <cheese@nosuchhost.net> - 1.7.4-1
- bump version

* Fri Jun 03 2016 josef radinger <cheese@nosuchhost.net> - 1.7.2-1
- bump version

* Fri Apr 29 2016 josef radinger <cheese@nosuchhost.net> - 1.7.1-1
- bump version
- update Patch1
- fix link on libgmic
- remove smp_mflags (because of compile-errors)
- split a *-static package

* Fri Feb 5 2016 josef radinger <cheese@nosuchhost.net> - 1.6.9-1
- bump version
- update Patch1

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.6.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Dec 7 2015 josef radinger <cheese@nosuchhost.net> - 1.6.8-1
- bump version

* Sat Oct 24 2015 josef radinger <cheese@nosuchhost.net> - 1.6.7-1
- bump version
- new downloadurl

* Tue Oct 13 2015 josef radinger <cheese@nosuchhost.net> - 1.6.6.1-1
- bump version

* Tue Jun 23 2015 Daniel P. Berrange <berrange@redhat.com> - 1.6.5.0-1
- Update to 1.6.5.0 release
- Enable zart binary build

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.6.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun May 10 2015 Daniel P. Berrange <berrange@redhat.com> - 1.6.2.0-1
- Update to 1.6.2.0 release

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 1.6.1.0-2
- Rebuilt for GCC 5 C++11 ABI change

* Fri Mar 20 2015 Daniel P. Berrange <berrange@redhat.com> - 1.6.1.0-1
- Update to 1.6.1.0 release

* Fri Feb  6 2015 Daniel P. Berrange <berrange@redhat.com> - 1.6.0.4-1
- Update to 1.6.0.4 release

* Fri Dec 19 2014 Daniel P. Berrange <berrange@redhat.com> - 1.6.0.3-1
- Update to 1.6.0.3 release

* Wed Nov 26 2014 Rex Dieter <rdieter@fedoraproject.org> 1.6.0.1-2
- rebuild (openexr), s|qt-devel|qt4-devel|, tighten subpkg deps

* Fri Oct  3 2014 Daniel P. Berrange <berrange@redhat.com> - 1.6.0.1-1
- Update to 1.6.0.1 release

* Mon Aug 25 2014 Daniel P. Berrange <berrange@redhat.com> - 1.6.0.0-1
- Update to 1.6.0.0 release

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.9.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Wed Jul 23 2014 Daniel P. Berrange <berrange@redhat.com> - 1.5.9.4-1
- Initial Fedora package after review (rhbz #1061801)

